%define ALD_Ver		1.2.4

%define OrgName util-linux-box
Name:         uC-%{OrgName}

License:      GPL
Summary:      Basic module utilities
Group:        System Environment/Base
Version:      2.26.2
Release:      1025.0

Source: %{OrgName}-%{version}.tar.xz
Source1: CROSS-uC.sh

%define uC_Version 1.0.25
%define DestDir		/Embedded/uC-%{uC_Version}

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%else
# rpm --target=x86_64/armv6l -ba xxxxx.spec
%define _CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6zk
%define ARM_FPU  -mfpu=vfp -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=hard
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
# -----------------------------------------------------

%define _lib lib

#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
ERROR: target=%{_os}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/usr/uC/%{uC_Version}/static/bin
%define target_  %{target}-

%define __os_install_post %{nil}

%define _srcrpmdir %{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir %{nil}
%define csysbindir	/usr/uC/%{uC_Version}/static/bin
%define CrossDestDir %{nil}
%define _srcrpmdir %{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_arch}-uclibc
%define target_  %{nil}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{OrgName}

# ------------------- description ------------------------------------
%description
Basic module utilities
#-------------------------------
%package mount
Summary:      Basic system
Group:        System Environment/Base
%description mount
Basic system
#-------------------------------
%package umount
Summary:      Basic system
Group:        System Environment/Base
%description umount
Basic system
#-------------------------------
%package cfdisk
Summary:      Basic system
Group:        System Environment/Base
%description cfdisk
Basic system
#-------------------------------
%package fdisk
Summary:      Basic system
Group:        System Environment/Base
%description fdisk
Basic system
#-------------------------------
%package fstrim
Summary:      Basic system
Group:        System Environment/Base
%description fstrim
Basic system
#-------------------------------
%package sfdisk
Summary:      Basic system
Group:        System Environment/Base
%description sfdisk
Basic system
#-------------------------------
%package eject
Summary:      Basic system
Group:        System Environment/Base
%description eject
Basic system

# ------------------- setup ------------------------------------------
%Prep
%setup -q -n %{OrgName}-%{version}

# ------------------- Build ------------------------------------------
%Build
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
UCLIBC_GCC_INC_SKIP=%{csysdir}/usr/include
export PATH GCC_NoHostPath UCLIBC_GCC_INC_SKIP


GCC_VER_STR=`%{target_}gcc -dumpversion`

%if %{_arch} == "i386"
OPTFLAGS="-Os -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-Os"
OPT47=`case $GCC_VER_STR in 4.[789].*) echo "-fno-asynchronous-unwind-tables" ;; esac`
%endif
%if %{_arch} == "arm"
OPTFLAGS="-Os -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
OPT47=
%endif

CFLAGS="$OPTFLAGS $OPT47 -ffunction-sections -fdata-sections -fno-stack-protector -std=gnu99"
LDFLAGS="-Wl,--gc-sections"

CC="%{target_}gcc"
AR="%{target_}ar"
STRIP="%{target_}strip"


IPATH=%{csysdir}/usr/uC/%{uC_Version}/static/include

export CC AR STRIP CFLAGS LDFLAGS IPATH

make &>FMake_log.txt


# ------------------- Install ----------------------------------------
%Install
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath

TARGET_PRFIX=%{_prefix}
TARGET_CROSS_PRFIX=%{csysdir}
TARGET_NAME=%{target}
MKCROSSDIR=0
export TARGET_PRFIX TARGET_CROSS_PRFIX TARGET_NAME MKCROSSDIR

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cp AUTHORS README README.licensing $RPM_BUILD_ROOT%{docdir}/
ln -s /usr/share/doc/gpl-2.0.txt $RPM_BUILD_ROOT%{docdir}/COPYING

%if %{_CROSS}
%SOURCE1
%endif #_CROSS

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{name} -v %{version} -r %{DestDir} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

DE=%{version}-%{release}.%{TO_ARCH}.rpm
DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{DestDir}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-mount-$SE $DD/%{name}-mount-$DE
  mv %{name}-umount-$SE $DD/%{name}-umount-$DE
  mv %{name}-cfdisk-$SE $DD/%{name}-cfdisk-$DE
  mv %{name}-fdisk-$SE $DD/%{name}-fdisk-$DE
  mv %{name}-fstrim-$SE $DD/%{name}-fstrim-$DE
  mv %{name}-sfdisk-$SE $DD/%{name}-sfdisk-$DE
  mv %{name}-eject-$SE $DD/%{name}-eject-$DE
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
  TMP_TO=$DD/tar
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}.%{TO_ARCH}
  mkdir -p $tmp
  cp -r bin sbin usr $tmp/
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%files
/sbin/util-linux-box
%{docdir}

%files mount
/bin/mount
%{_mandir}/man8/mount.*

%files umount
/bin/umount
%{_mandir}/man8/umount.*

%files cfdisk
/sbin/cfdisk
%{_mandir}/man8/cfdisk.*

%files fdisk
/sbin/fdisk
%{_mandir}/man8/fdisk.*

%files fstrim
/sbin/fstrim
%{_mandir}/man8/fstrim.*

%files sfdisk
/sbin/sfdisk
%{_mandir}/man8/sfdisk.*

%files eject
/usr/bin/eject
%{_mandir}/man1/eject.*
